<?xml version="1.0" encoding="iso-8859-1"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:x="urn:oasis:names:tc:ubl:schema:XPath-1.0"
                version="1.0">

<!--
     Illustration of access to XPath information files.
     $Id: xpath.xsl,v 1.4 2005/05/31 02:41:09 G. Ken Holman Exp $

Copyright (C) OASIS Open (2005). All Rights Reserved.

This document and translations of it may be copied and furnished 
to others, and derivative works that comment on or otherwise 
explain it or assist in its implementation may be prepared, 
copied, published and distributed, in whole or in part, without 
restriction of any kind, provided that the above copyright notice 
and this paragraph are included on all such copies and derivative 
works. However, this document itself may not be modified in any 
way, such as by removing the copyright notice or references to 
OASIS, except as needed for the purpose of developing OASIS 
specifications, in which case the procedures for copyrights 
defined in the OASIS Intellectual Property Rights document must 
be followed, or as required to translate it into languages other 
than English.

The limited permissions granted above are perpetual and will not 
be revoked by OASIS or its successors or assigns.

This document and the information contained herein is provided 
on an "AS IS" basis and OASIS DISCLAIMS ALL WARRANTIES, EXPRESS 
OR IMPLIED, INCLUDING BUT NOT LIMITED TO ANY WARRANTY THAT THE 
USE OF THE INFORMATION HEREIN WILL NOT INFRINGE ANY RIGHTS OR ANY 
IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR 
PURPOSE.

-->

<xsl:output method="text"/>

<xsl:template match="/x:XPath">
  <!--expose the resource identifier for the file-->
  <xsl:value-of select="concat('# ',@id)"/><xsl:text>
</xsl:text>
  <!-- walk through the file contents-->
  <xsl:apply-templates select="*"/>
</xsl:template>

<!--create a line for each element and attribute-->
<xsl:template match="x:Element | x:Attribute">
  <!--synthesize the XPath string-->
  <xsl:for-each select="ancestor-or-self::x:Element">
    <xsl:value-of select="concat('/',@prefix,':',@name)"/>
  </xsl:for-each>
  <xsl:for-each select="self::x:Attribute">
    <xsl:value-of select="concat('/@',@name)"/>
  </xsl:for-each>
  <!--indicate for elements without text that they are intermediate-->
  <xsl:if test="self::x:Element[not(@text)]">/</xsl:if>
  <xsl:text>
</xsl:text>
  <!-- process the child XPath information-->
  <xsl:apply-templates select="*"/>
</xsl:template>

</xsl:stylesheet>